import * as redis from './redis.js'
import { updateVersionProcessor, registerLatestVersionListener } from './version.js'

const { getQueue, subClient } = redis

export default function createQueues () {
  if (redis.isEnabled()) {
    const updateVersionQueue = getQueue('update-version')
    updateVersionQueue.process(updateVersionProcessor)
    updateVersionQueue.add({}, {
      jobId: 'update-version-job',
      repeat: { every: Number(process.env.CACHE_TTL) },
      removeOnComplete: 10,
      removeOnFail: 10,
      timeout: 10000
    })

    // not a queue but though, used by redis
    registerLatestVersionListener(subClient)
  } else {
    setInterval(updateVersionProcessor, Number(process.env.CACHE_TTL))
  }
}
